#include "..\avisynth.h"
//#include <string.h>
//#define VIDEOSCOPE_VERSION 1

struct YUY2pixelByte {
  unsigned char Y1;
  unsigned char U;
  unsigned char Y2;
  unsigned char V;
};
struct YUY2pixelInt {
  int Y1;
  int U;
  int Y2;
  int V;
};
struct YUVpixelInt {
  int Y;
  int U;
  int V;
};
struct RGBpixelInt {
  int R;
  int G;
  int B;
};

/*********************************************************************/
/*********************************************************************/
//  class
//
class ShowDelta : public GenericVideoFilter
{

public:
  ShowDelta(PClip _child, IScriptEnvironment* env);
  PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
  ~ShowDelta();

};
/*********************************************************************/
// destructor
//
ShowDelta::~ShowDelta()
{
}

/*********************************************************************/
// add function (avisynth specific)
//
AVSValue __cdecl Create_ShowDelta(AVSValue args, void* user_data, IScriptEnvironment* env)
{
  return new ShowDelta(args[0].AsClip(), env);
}

/*********************************************************************/
/*********************************************************************/
//  Constructor
//
ShowDelta::ShowDelta(PClip _child, IScriptEnvironment* env)
  : GenericVideoFilter(_child)
{
  if(!vi.IsYUY2())
	env->ThrowError("ShowDelta: only YUY2 for now");
}

/*********************************************************************/
/*********************************************************************/
//  GetFrame
//
PVideoFrame __stdcall ShowDelta::GetFrame(int n, IScriptEnvironment* env)
{
  PVideoFrame prev = child->GetFrame(n-1, env);
  PVideoFrame src = child->GetFrame(n, env);
  PVideoFrame dst = env->NewVideoFrame(vi);
  const unsigned char *srcHome = src->GetReadPtr(), *srcPtr;
  const unsigned char *prevHome = prev->GetReadPtr(), *prevPtr;
  unsigned char *dstHome = dst->GetWritePtr(), *dstPtr;
//  int dy1, du, dy2, dv;
  

/*********************************************************************/
// copy the original frame
//
//  env->BitBlt(dst->GetWritePtr(), dst->GetPitch(), src->GetReadPtr(), src->GetPitch(), src->GetRowSize(), src->GetHeight());

  for(int y=0; y<src->GetHeight(); y++) {
	srcPtr = srcHome + y*src->GetPitch();
	prevPtr = prevHome + y*prev->GetPitch();
	dstPtr = dstHome + y*dst->GetPitch();
	for(int x=0; x<src->GetRowSize(); x+=4) {
	  dstPtr[0] = (srcPtr[0] - prevPtr[0])+128;
	  dstPtr[1] = (srcPtr[1] - prevPtr[1])+128;
	  dstPtr[2]= (srcPtr[2] - prevPtr[2])+128;
	  dstPtr[3] = (srcPtr[3] - prevPtr[3])+128;
	  srcPtr+=4; prevPtr+=4; dstPtr+=4;
	}
  }

  return dst;
} // end GetFrame

/*********************************************************************/
/*********************************************************************/
// 
//
